# **風船ゲーム**
下から流れてくる風船を割っていくゲームを作りました    
tkinter や random 、python における複素数の扱い方はネットで調べました  
<br>

# 風船のアニメーション

```python
class Balloons:
    def __init__(self,x,y,dx,dy,n,img,r,e,number,g):
        self.x=x
        self.y=y
        self.dx=dx
        self.dy=dy
        self.n=n
        self.img=img
        self.r=r
        self.e=e
        self.number=number
        self.g=g
```
クラス作成
<br>

## 風船の基本的な動き
```python
    def move(self):
        global v,vv,vvv,vx,vxx
        if self.y<=-100 or (self.dy>vvv and self.y>z+300):
            canvas.delete(self.n)
            self.x=-2000
            self.y=-2000
            self.dx=0
            self.dy=0
        elif self.y>-100:
            if self.number==40 and self.y<z and vx==False:
                v=v*1.3
                vv=vv*1.3
                vx=True
            if self.number==100 and self.y<z and vxx==False:
                v=v*1.3
                vv=vv*1.3
                vxx=True
            canvas.delete(self.n)
            if self.dy>-vvv:
                self.dy=self.dy-0.02
            if self.x-self.r<0 or canvas.winfo_width()<self.x+self.r:
                self.dx=-self.dx
            if self.y>z and self.e==False:
                self.y=self.y-vvv
            else:    
                self.x=self.x+self.dx
                self.y=self.y+self.dy
            self.n=canvas.create_image(self.x,self.y,image=self.img)
```
風船の中心のx座標とy座標にそれぞれdx、dyを足すことで風船を動かしています   
予め画面の下の方に風船たちが設定されていて、順番に上昇してきます  
上昇速度は二段階で上昇します  
一定の速度で上昇し、画面内に現れる直前にx方向にも移動を始めます  
役割を終えた風船たちは画面外に行き停止します  

<br>

## 風船同士の衝突
```python
    def bound():
         for a in balloons:
            if -100<a.y<z+400:
                 for b in balloons:
                    if -100<a.y<z+400 and -100<b.y<z+400:
                        if -140<a.x-b.x<140 and -140<a.y-b.y<140:
                            l=(a.x-b.x)**2+(a.y-b.y)**2
                            if 0<l<=(a.r+b.r)**2:
                                if a.g and b.g:
                                    a.x=-2000
                                    a.y=-2000
                                    a.dx=0
                                    a.dy=0
                                else:
                                    canvas.delete(a.n) 
                                    a.x=a.x-a.dx
                                    a.y=a.y-a.dy
                                    a.n=canvas.create_image(a.x,a.y,image=a.img)
                                    canvas.delete(b.n) 
                                    b.x=b.x-b.dx
                                    b.y=b.y-b.dy
                                    b.n=canvas.create_image(b.x, b.y, image=b.img)

                                    m1=(complex(a.dx,a.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                                    n1=m1.imag
                                    m2=(complex(b.dx,b.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                                    n2=m2.imag
                                    p1=(complex(a.dx,a.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                                    q1=p1.real
                                    p2=(complex(b.dx,b.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                                    q2=p2.real
                                    s1=complex(q2,n1)
                                    s2=complex(q1,n2)
                                    t1=s1*(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                                    t2=s2*(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                                    a.dx=t1.real
                                    a.dy=t1.imag
                                    b.dx=t2.real
                                    b.dy=t2.imag
                                    a.g=True
                                    b.g=True
                            elif a.g and b.g:
                                a.g=False
                                b.g=False
```
全ての通りで二つの風船の組み合わせを作り、それらが衝突しているか判定します  
処理速度を上げるために画面内の風船だけマッチングさせ、かつ明らかに離れている風船同士も省きました    
稀にうまく反発しないことがあるので、その時にはどちらかの風船が消えるようになっています  

<br>

### これらを繰り返し実行
```python
def loop():
    for a in balloons:
        a.move()
    Balloons.bound()
    root.after(11,loop)
```
<br>

# 風船を割る
```python                     
class Cursor:
    def __init__(self,X,Y):
        self.X=X
        self.Y=Y
```
<br>

## クリック（画面タッチ）
```python
    def click(self,event):
        self.X=event.x
        self.Y=event.y
        global w,point,point2,s,t1,t2,t3,t4,t5,point3
        canvas.delete(point3)
        for a in balloons:
            if -100<a.y<z and -a.r<self.X-a.x<a.r and -a.r<self.Y-a.y<a.r:
                l2=(self.X-(a.x-a.dx*5))**2+(self.Y-(a.y-a.dy*5))**2
                if l2<(a.r)**2:
                    canvas.delete(w)
                    p=a.x
                    q=a.y
                    a.x=-2000
                    a.y=-2000
                    a.dx=0
                    a.dy=0
                    if a.img==img1:
                        w=canvas.create_image(p,q,image=img12)
                    if a.img==img2:
                        w=canvas.create_image(p,q,image=img22)
                    if a.img==img3:
                        w=canvas.create_image(p,q,image=img32)
                    if a.img==img4:
                        w=canvas.create_image(p,q,image=img42)
                    if a.img==img5:
                        w=canvas.create_image(p,q,image=img52)
                    if a.img==img6:
                        w=canvas.create_image(p,q,image=img62)
                    if a.img==img7:
                        w=canvas.create_image(p,q,image=img72)
                    if a.img==img8:
                        w=canvas.create_image(p,q,image=img82)
                    point=point+500
                    if a.img==img8:
                        point=point-1500
                        point3=canvas.create_text(370,630,text="- 1 0 0 0",font=("Bauhaus 93",24),fill="black",anchor=tk.SE)
                    if s==a.img and a.img!=img8:
                        point=point+1000
                        point3=canvas.create_text(370,630,text="+ 1 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    if a.img==img2 and s==img1:
                        t1=True
                        point=point+1000
                        point3=canvas.create_text(370,630,text="+ 1 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    elif a.img==img3 and t1 and s==img2:
                        t2=True
                        point=point+1200
                        point3=canvas.create_text(370,630,text="+ 1 2 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    elif a.img==img4 and t2 and s==img3:
                        t3=True
                        point=point+1600
                        point3=canvas.create_text(370,630,text="+ 1 6 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    elif a.img==img5 and t3 and s==img4:
                        t4=True
                        point=point+2200
                        point3=canvas.create_text(370,630,text="+ 2 2 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    elif a.img==img6 and t4 and s==img5:
                        t5=True
                        point=point+3000
                        point3=canvas.create_text(370,630,text="+ 3 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    elif a.img==img7 and t5 and s==img6:
                        point=point+4000
                        point3=canvas.create_text(370,630,text="+ 4 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    else:
                        t1=t2=t3=t4=t5=False
                    if a.number==217:
                        ran=random.choice((1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20))
                        if 1<=ran<=10:
                            point=point+1000
                            point3=canvas.create_text(370,630,text="+ 1 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                        elif 11<=ran<=16:
                            point=point+3000
                            point3=canvas.create_text(370,630,text="+ 3 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                        elif 17<=ran<=19:
                            point=point+5000
                            point3=canvas.create_text(370,630,text="+ 5 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                        elif ran==20:
                            point=point+10000
                            point3=canvas.create_text(370,630,text="+ 1 0 0 0 0",font=("Bauhaus 93",30),fill="black",anchor=tk.SE)
                    canvas.delete(point2)
                    point2=canvas.create_text(335,690,text=str(point),font=("Bell MT",42),fill="white",anchor=tk.SE)
                    s=a.img
```
クリック（タッチ）された風船は消え、割れた風船のイラストが表示されます  
風船を消すと得点が入ります  
同じ色の風船を連続で消すと、その都度加点されます  
また、画面下に表示されている風船の色の順で消すとさらに高い点が加点されます  
<br>

## カーソルを合わせてスペースキーで割る
```python
    def cursor(self,event):
        self.X=event.x
        self.Y=event.y
    def cursor2(self):
        global N
        if self.X!=None and self.Y!=None:
            canvas.delete(N)
            N=canvas.create_image(self.X,self.Y,image=img00)
    def key(self,e):
        if e.keysym=="space":
            
            略（上と同じ）

        global f,kk
        if e.keysym=="r" and kk==False:
            f=canvas.create_image(560,430,image=img000)
            kk=True
```
クリック（タッチ）だけでなく、カーソルを移動してスペースキーを押すことでも消せます  
得点の入り方は上と同じです  
<br>

### カーソルのアニメーション
```python
def loop2():
    cursor.cursor2()
    root.after(11,loop2)
```
<br>

```python
N=None
w=None
point=0
point2=canvas.create_text(335,690,text="0",font=("Bell MT",42),fill="white",anchor=tk.SE)
s=None
t1=False
t2=False
t3=False
t4=False
t5=False
point3=None
```
<br>

# 開始ボタン
```python
button1=tk.Button(root,text="GAME START",font=("Bell MT",48),command=Button1Click)
button1.place(x=370,y=150)
img000=tk.PhotoImage(file="balloons/rule.png")
kk=False
f=None

def Button1Click():
    button1.place(x=-2000,y=-2000)
    canvas.delete(f)
    global kk
    kk=True
    loop()
    loop2()
```
開始ボタンを押す前に r キーを押すと簡単なルール説明が出ます  
<br>

# 背景の配置
```python
root=tk.Tk()
root.geometry("1100x700")
root.configure(bg="#000000")
canvas=tk.Canvas(root,width=1100,height=700,bg="white")
canvas.place(x=50,y=0)
root.state("zoomed")

cursor=Cursor(None,None)
root.bind('<Motion>', cursor.cursor)
img00=tk.PhotoImage(file="balloons/syoujyun.png")
root.bind("<KeyPress>",cursor.key)
root.bind("<Button-1>",cursor.click)
img0=tk.PhotoImage(file="balloons/sora.png")
canvas.create_image(550,350,image=img0)
img02=tk.PhotoImage(file="balloons/keijiban.png")
canvas.create_image(200,660,image=img02)

img1=tk.PhotoImage(file="balloons/balloon1.png")
img2=tk.PhotoImage(file="balloons/balloon2.png")
img3=tk.PhotoImage(file="balloons/balloon3.png")
img4=tk.PhotoImage(file="balloons/balloon4.png")
img5=tk.PhotoImage(file="balloons/balloon5.png")
img6=tk.PhotoImage(file="balloons/balloon6.png")
img7=tk.PhotoImage(file="balloons/balloon7.png")
img8=tk.PhotoImage(file="balloons/balloon8.png")
img12=tk.PhotoImage(file="balloons/balloon1'.png")
img22=tk.PhotoImage(file="balloons/balloon2'.png")
img32=tk.PhotoImage(file="balloons/balloon3'.png")
img42=tk.PhotoImage(file="balloons/balloon4'.png")
img52=tk.PhotoImage(file="balloons/balloon5'.png")
img62=tk.PhotoImage(file="balloons/balloon6'.png")
img72=tk.PhotoImage(file="balloons/balloon7'.png")
img82=tk.PhotoImage(file="balloons/balloon8'.png")
img9=tk.PhotoImage(file="balloons/gold.png")

img11=img1.subsample(2)
img21=img2.subsample(2)
img31=img3.subsample(2)
img41=img4.subsample(2)
img51=img5.subsample(2)
img61=img6.subsample(2)
img71=img7.subsample(2)
img81=img8.subsample(2)

canvas.create_image(400,660,image=img11)
canvas.create_text(400,660,text="500",font=("Bell MT",26),fill="white")
canvas.create_image(450,660,image=img21)
canvas.create_text(450,660,text="500",font=("Bell MT",26),fill="white")
canvas.create_image(500,660,image=img31)
canvas.create_text(500,660,text="500",font=("Bell MT",26),fill="white")
canvas.create_image(550,660,image=img41)
canvas.create_text(550,660,text="500",font=("Bell MT",26),fill="white")
canvas.create_image(600,660,image=img51)
canvas.create_text(600,660,text="500",font=("Bell MT",26),fill="white")
canvas.create_image(650,660,image=img61)
canvas.create_text(650,660,text="500",font=("Bell MT",26),fill="white")
canvas.create_image(700,660,image=img71)
canvas.create_text(700,660,text="500",font=("Bell MT",26),fill="white")
canvas.create_image(800,660,image=img81)

canvas.create_text(800,660,text="-1000",font=("Bell MT",21),fill="white")
```
<br>

# 風船たち
```python
j=4
l=180
m=700
v=15
vv=25
vvv=v/10
vx=False
vxx=False
z=1100

balloons=[
            Balloons(275,m+1*l,random.uniform(-j,j),-(random.randint(v,vv))/10,None,random.choice((img1,img2,img3,img4,img5,img6,img7,img8)),68,False,1,False),
            Balloons(550,m+1*l,random.uniform(-j,j),-(random.randint(v,vv))/10,None,random.choice((img1,img2,img3,img4,img5,img6,img7,img8)),68,False,2,False),
            
            略（３～２１５）

            Balloons(825,m+72*l,random.uniform(-j,j),-(random.randint(v,vv))/10,None,random.choice((img1,img2,img3,img4,img5,img6,img7,img8)),68,False,216,False), 
            Balloons(550,m+74*l,random.uniform(-j,j),-(random.randint(v,vv))/10,None,img9,68,False,217,False), 
            ]
```
<br>
<br>

```python
root.mainloop()
```
<br>
<br>
<br>
Copyright (c) <year> <copyright holders>  

以下に定める条件に従い、本ソフトウェアおよび関連文書のファイル（以下「ソフトウェア」）の複製を取得するすべての人に対し、ソフトウェアを無制限に扱うこと
を無償で許可します。これには、ソフトウェアの複製を使用、複写、変更、結合、掲載、頒布、サブライセンス、および/または販売する権利、およびソフトウェアを提
供する相手に同じことを許可する権利も無制限に含まれます。  
上記の著作権表示および本許諾表示を、ソフトウェアのすべての複製または重要な部分に記載するものとします。  
ソフトウェアは「現状のまま」で、明示であるか暗黙であるかを問わず、何らの保証もなく提供されます。ここでいう保証とは、商品性、特定の目的への適合性、およ
び権利非侵害についての保証も含みますが、それに限定されるものではありません。作者または著作権者は、契約行為、不法行為、またはそれ以外であろうと、ソフト
ウェアに起因または関連し、あるいはソフトウェアの使用またはその他の扱いによって生じる一切の請求、損害、その他の義務について何らの責任も負わないものとし
ます。